﻿using UnityEngine;
using System.Collections;


public class ExplosionPiece : MonoBehaviour
{
	public void Explode (float force, Vector3 position, float radius)
	{
		GameObject piece = GameObject.Instantiate (this.gameObject);
		piece.transform.SetParent (null);
		piece.transform.CopyPositionRotation (transform);

		Rigidbody pieceRigidbody = piece.AddComponent<Rigidbody> ();

		pieceRigidbody.AddExplosionForce (force, position, radius);

		gameObject.SetActive (false);
		piece.AddComponent<AutoDestruct> ().delay = 5f;
		SetLayer (piece.transform, 31);
	}

	private void SetLayer (Transform rootTransform, int layer)
	{
		rootTransform.gameObject.layer = layer;
		for (int i = 0; i < rootTransform.childCount; i++)
			SetLayer (rootTransform.GetChild (i), layer);
	}

	public void Reset ()
	{
		gameObject.SetActive (true);
	}
}
