﻿using UnityEngine;
using UnityEngine.Events;
using System.Collections;

public abstract class GadgetBehavior : MonoBehaviour
{
	public UnityEvent onStart;
	public UnityEvent onStop;
	private bool isWorking = false;

	public bool IsWorking {
		get { return isWorking; }
		set {
			if (isWorking != value) {
				isWorking = value;

				OnIsWorkingChanged ();

				if (isWorking)
					onStart.Invoke ();
				else
					onStop.Invoke ();
			}
		}
	}

	protected abstract void OnIsWorkingChanged ();
}
