﻿using UnityEngine;
using UnityEngine.Events;
using System.Collections;

public class GadgetBehaviorRedir : GadgetBehavior
{
	public float minVelocity = 2;

	protected override void OnIsWorkingChanged ()
	{
		
	}

	void OnTriggerStay (Collider other)
	{
		if (IsWorking) {
			if (other.attachedRigidbody != null && !other.attachedRigidbody.isKinematic) {
				Vector3 redir = transform.forward;
				redir.y = 0;
				redir.Normalize ();
				Vector3 newVelocity = other.attachedRigidbody.velocity;
				float horizontalSpeed = new Vector3 (newVelocity.x, 0, newVelocity.z).magnitude;
				horizontalSpeed = Mathf.Max (minVelocity, horizontalSpeed);
				newVelocity = redir * horizontalSpeed + Vector3.up * newVelocity.y;
				other.attachedRigidbody.velocity = newVelocity;
			}
		}
	}
}
