﻿using UnityEngine;
using System.Collections;

[RequireComponent (typeof(AudioSource))]
public class GadgetSound : MonoBehaviour
{
	public GadgetBehaviorTimed gadgetBehavior;
	public AudioClipPlaySetting tweenStartSound;
	public AudioClipPlaySetting tweenCompleteSound;
	private AudioSource myAudio;

	void Start ()
	{
		myAudio = GetComponent<AudioSource> ();
		gadgetBehavior.TweenStarted += HandleTweenStarted;
		gadgetBehavior.TweenCompeted += HandleTweenCompeted;
	}

	void HandleTweenStarted (GadgetBehaviorTimed behavior)
	{
		GlobalSoundPlayer.PlaySound (tweenStartSound);
	}

	void HandleTweenCompeted (GadgetBehaviorTimed behavior)
	{
		GlobalSoundPlayer.PlaySound (tweenCompleteSound);
	}

	void Update ()
	{
		if (myAudio.clip != null) {
			if (gadgetBehavior.IsTweening) {
				if (!myAudio.isPlaying)
					myAudio.Play ();
			} else {
				if (myAudio.isPlaying)
					myAudio.Stop ();
			}
		}
	}
}
