﻿using UnityEngine;
using System.Collections;

public class GameSceneCommandState : GameSceneState
{
	public GameSceneStateTypes stateType;
	public CoroutineCommandBehavior command;

	public override GameSceneStateTypes StateId { get { return stateType; } }

	public override void BeginState (GameSceneStateTypes previousState)
	{
		base.BeginState (previousState);
		StartCoroutine (RunCommand ());
	}

	protected IEnumerator RunCommand ()
	{
		yield return StartCoroutine (command.ExecuteCoroutine ());

		OnCommandCompleted ();
	}

	protected virtual void OnCommandCompleted ()
	{
		
	}
}
