﻿using UnityEngine;
using UnityEngine.SceneManagement;
using System.Collections;

public class GameSceneController : MonoBehaviour
{
	private static ObjectInstanceFinder<GameSceneController> instanceFinder = new ObjectInstanceFinder<GameSceneController> ();

	public static GameSceneController Instance{ get { return instanceFinder.Instance; } }

	public bool testGameLevels = false;

	private Fsm<GameSceneController, GameSceneStateTypes> finiteStateMachine;

	public GameSceneStateGame GameState {
		get { return FiniteStateMachine.GetState (GameSceneStateTypes.Game) as GameSceneStateGame; }
	}

	public Fsm<GameSceneController, GameSceneStateTypes> FiniteStateMachine {
		get {
			if (finiteStateMachine == null) {
				finiteStateMachine = new Fsm<GameSceneController, GameSceneStateTypes> (this);
				finiteStateMachine.AddStates (GetComponentsInChildren<GameSceneState> (true));
				finiteStateMachine.GotoState (GameSceneStateTypes.Home);
			}
			return finiteStateMachine;
		}
	}

	void Start ()
	{
		if (Application.isEditor && testGameLevels)
			FiniteStateMachine.GotoState (GameSceneStateTypes.Game);
		else
			FiniteStateMachine.GotoState (GameSceneStateTypes.Home);
	}
}
